//------------------------------------------------------------------------
//
//  editbar.prg
//
//  Toolbar with rowset editing tool buttons.
//  To use:
/* 
     DO editbar.prg WITH f       // for small tool buttons
     DO editbar.prg WITH f, true // for large tool buttons
*/
//           do regbar.prg with this
///------------------------------------------------------------------------  

   parameter FormObj, bLarge
   local t, bNew
   t    = null
   bNew = false
   if ( PCOUNT() == 0 )
      MSGBOX("To attach this toolbar to a form use: " + ;
              CHR(13) + CHR(13) + ;
             "DO " + PROGRAM() + " WITH <form reference>","Alert")
   else
      t := FindInstance("EdSpelarebar")
      if ( ( t == null ) or ( not FormObj.mdi ) )
         SET PROCEDURE TO (PROGRAM()) ADDITIVE
         t = new EdSpelarebar( bLarge )
         bNew := true
      endif
      t.attach( FormObj )  
   endif

return ( bNew )

class EdSpelarebar( bLarge ) of Toolbar
   local sBitsize
   sBitsize = IIF( bLarge, "TL_", "TS_" )

   this.flat     := true
   this.text     := "Editera"
   this.onUpdate := class::edit_onUpdate

*   this.tAppend = new ToolButton( this )
*   with ( this.tAppend )
*        bitmap   := "RESOURCE " + sBitsize + "APPEND"
*        speedTip := "Ny "
*        onClick  := class::tAppend_onClick
*   endwith

   this.tDelete = new ToolButton( this )
   with ( this.tDelete )
        bitmap   := "RESOURCE " + sBitsize + "DELETE"
        speedTip := "Ta bort"
        onClick  := class::tDelete_onClick
   endwith
   
   this.tSave = new ToolButton( this )
   with ( this.tSave )
        bitmap   := "RESOURCE " + sBitsize + "SAVE"
        speedTip := "Spara ndringar"
        onClick  := class::tSave_onClick
   endwith

   this.tAbandon = new ToolButton( this )
   with ( this.tAbandon )
        bitmap   := "RESOURCE " + sBitsize + "ABANDON"
        speedTip := "Spara inte ndringarna"
        onClick  := class::tAbandon_onClick
   endwith

   function edit_onUpdate
      LOCAL bRowFound
      bRowFound = ( TYPE("this.form.query1.rowset") == "O" )
*      this.tAppend.enabled  := bRowFound
      this.tDelete.enabled  := bRowFound
      this.tSave.enabled    := bRowFound
      this.tAbandon.enabled := bRowFound

   return ( bRowFound )

*   function tAppend_onClick
*
*      this.parent.form.query1.rowset.save()
*      if this.parent.form.text = 'Vira SM'
*         vomg = this.parent.form.query1.rowset.fields["omgng"].value
*         var = this.parent.form.query1.rowset.fields["SPELR"].value
*         v1 = this.parent.form.query1.rowset.fields["vikt1"].value
*         v2 = this.parent.form.query1.rowset.fields["vikt2"].value
*      endif
*
*      this.parent.form.query1.rowset.beginAppend()
*
*      if this.parent.form.text = 'Vira SM'
*         this.parent.form.query1.rowset.fields["omgng"].value = vomg
*         this.parent.form.SPINBOXOMGNG1.value = vomg 
*
*         this.parent.form.query1.rowset.fields["SPELR"].value = var
*         this.parent.form.ENTRYFIELDSPELR1.value = var
*
*         this.parent.form.query1.rowset.fields["vikt1"].value = v1
*
*
*         this.parent.form.query1.rowset.fields["vikt2"].value = v2
*         this.parent.form.query1.rowset.fields["resultat"].value = 0
*         this.parent.form.query1.rowset.fields["viktat_resultat"].value = 0
*
* 
*
*      endif
*      this.parent.form.query1.rowset.save()
*
*   return 


   function tDelete_onClick


      local bDelete, bFirst
      bDelete = false
      bFirst  = false
      if ( not this.parent.form.query1.rowset.endOfSet )
         if ( MSGBOX("Du kommer att ta bort denna rad i tabellen." ;
                   + CHR(13) ;
                   + "Klicka p Ja fr borttag.", ;
                     "OBSERVERA !", ;
                     4) == 6 )

*            if this.parent.form.text = 'Lag'
*               qb2 = NEW QUERY()
*               qb2.sql = "update 'grupp.dbf' set ant_lag = ant_lag - 1 where Tkod = :p1 and Gkod = :p2"
*               qb2.params["p1"] = trim(ptkod)
*               qb2.params["p2"] = trim(pgkod)
*               qb2.active = true
*               qb2.rowset.save()
*               qb2.rowset.refresh()
*               qb2.active = false
*               MSGBOX("Antal lag fr gruppen r minskad med 1.", "Info", 64)
*            endif




            bFirst  := this.parent.form.query1.rowset.atFirst()
            bDelete := this.parent.form.query1.rowset.delete()       
            if ( not bFirst ) 
               this.parent.form.query1.rowset.next(-1)
            endif
            if ( this.parent.form.query1.rowset.endOfSet )
               this.parent.form.query1.rowset.next()
            endif


         endif
      endif
   return ( bDelete )

   function tSave_onClick

   return ( this.parent.form.query1.rowset.save() )

   function tAbandon_onClick
   return ( this.parent.form.query1.rowset.abandon() )

endclass