//------------------------------------------------------------------------
//
//  clipbar.prg
//
//  Toolbar with clipboard tool buttons.
//  To use:
/* 
     f = new FishBarsForm()  
     DO clipbar.prg WITH f
*/
//  
//  Visual dBASE Samples Group  kopierad av steffe
//
//  $Revision:   1.5  $
//
//  Copyright (c) 1997, Borland International, Inc. All rights reserved.    
//
//------------------------------------------------------------------------  

   parameter FormObj, bLarge
   local t, bNew
   t    = null
   bNew = false

   if ( PCOUNT() == 0 )
       MSGBOX("To attach this toolbar to a form use: " + ;
              CHR(13) + CHR(13) + ;
             "DO " + PROGRAM() + " WITH <form reference>","Alert")
   else
      t := FindInstance("ClipToolbar")
      if ( ( t == null ) or ( not FormObj.mdi ) )
         SET PROCEDURE TO (PROGRAM()) ADDITIVE
         t = new ClipToolbar( bLarge )
         bNew := true
      endif
      t.attach( FormObj )  
    endif

return ( bNew )

class ClipToolbar( bLarge ) of Toolbar
   local sBitsize
   sBitsize = IIF( bLarge, "TL_", "TS_" )

   this.flat     := true
   this.text     := "Klipp och klistra"   
   this.onUpdate := class::clip_onUpdate

   this.tCut = new ToolButton( this )
   with ( this.tCut )
        bitmap   := "RESOURCE " + sBitsize + "CUT"
        speedTip := "Klipp ut"
        onClick  := class::tCut_onClick
   endwith

   this.tCopy = new ToolButton( this )
   with ( this.tCopy )  
        bitmap   := "RESOURCE " + sBitsize + "COPY"
        speedTip := "Kopiera"
        onClick  := class::tCopy_onClick
   endwith

   this.tPaste = new ToolButton( this )
   with ( this.tPaste )
        bitmap   := "RESOURCE " + sBitsize + "PASTE"
        speedTip := "Klistra in"
        onClick  := class::tPaste_onClick
   endwith 
* 
*   this.tBokn = new ToolButton( this )
*   with ( this.tBokn )
**        bitmap   := "filename " + "alarm.bmp"
*        bitmap   := "filename " + "calendar.bmp"
*        speedTip := "Tidsbokning"
*        onClick  := class::tBokn_onClick
*   endwith 
** 
**   this.flat     := true
**   this.text     := "Skriv ut"   
**   this.tPr = new ToolButton( this )
**   with ( this.tPr )
**        bitmap   := "RESOURCE #614"
**        speedTip := "Skriv ut."
**        onClick  := class::tPr_onClick
**   endwith

* function

   function clip_onUpdate
      local bClip
      bClip = false
      if ( TYPE("this.form.activeControl") == "O" )
         bClip := ( TYPE("this.form.activeControl.copy") == "FP" )
         with ( this )
            tCut.enabled   := TYPE("this.form.activeControl.cut") == "FP"
            tCopy.enabled  := TYPE("this.form.activeControl.copy" ) == "FP"
            tPaste.enabled := TYPE("this.form.activeControl.paste") == "FP"
         endwith
      else
         with ( this )
            tCut.enabled   := false
            tCopy.enabled  := false
            tPaste.enabled := false
         endwith
      endif
   return ( bClip )
  
   function tCut_onClick
   return ( this.parent.form.activeControl.cut() )

   function tCopy_onClick
   return ( this.parent.form.activeControl.copy() )

   function tPaste_onClick
   return ( this.parent.form.activeControl.paste() )
* 
*   function tBokn_onClick
*
*      local f
*      f = findinstance( "tidkalForm" )
*       ? '1:a empty'
*      if empty( f )
*         ? 'empty '  
*         qb2 = NEW QUERY()
*         qb2.sql = "select nr, fornamn from 'frisorer.dbf' where bokning = :p2 order by nr"
*         qb2.params["p2"] = true
*         qb2.active = true
*         qb2.rowset.first()
*         if qb2.rowset.count() = 0
*            MSGBOX("Inga frisrerer har markerats fr att vara med i tidsbokningen", "OBS!!", 0)
*            return 
*         endif
*         qb2.active = false
*         do tidkal.wfm
*      endif
*   return

*   function tPr_onClick
*     this.parent.form.query3.requery()
*     this.parent.form.query3.rowset.first()
*     this.parent.form.upnisse = new updateset()
*     this.parent.form.upnisse.source = this.parent.form.query3.rowset
*     this.parent.form.upnisse.destination = "c:\temp.dbf"
*     this.parent.form.upnisse.copy()
*     if this.parent.form.mdi = true
*        this.parent.form.mdi = false
*     else
*        this.parent.form.mdi = true
*     endif 
*      do utskrift.wfm
 
    return 


endclass